#!/bin/bash


wine=.winesapi
display=:20

# do not change below this line!

sapi=$(dirname $(readlink -f $0))

echo Changing current directory to ${sapi}

cd $sapi

function check_prog
{
    if ! which $1 >/dev/null 2>/dev/null; then
        echo "$1 not found, install package $2"
        return 1
    fi
    return 0
}

function open_xvfb
{
    if DISPLAY="$1" xdpyinfo >/dev/null 2>/dev/null ; then
        echo "Screen already exists"
        return
    fi
    nohup Xvfb -screen -0 800x600x16 -nolisten tcp $1 &
    sleep 2
}


bad="false"

check_prog wine wine
if [ $? == 1 ] ; then bad="true"; fi
check_prog icewm icewm
if [ $? == 1 ] ; then bad="true"; fi
check_prog xte xautomation
if [ $? == 1 ] ; then bad="true"; fi
check_prog xprop x11-utils
if [ $? == 1 ] ; then bad="true"; fi
check_prog Xvfb xvfb
if [ $? == 1 ] ; then bad="true"; fi
check_prog xdpyinfo x11-utils
if [ $? == 1 ] ; then bad = "true"; fi
check_prog nc netcat
if [ $? == 1 ] ; then bad = "true"; fi
if [ "$bad" == "true" ] ; then
    echo "Important programs not found, instalation abandoned"
    exit 1
fi

voices=$(find ivona_voices -type f -and -path "*.dat" -and -size +80M)

if [ "$voices]" == "" ] ; then
    echo "No Ivona voices found"
else
    vcount=0
    for a in $voices; do
        let "vcount=${vcount}+1"
    done
    
    if [ "$vcount" == "1" ] ; then
        echo "One Ivona voice found"
    else
        echo "${vcount} Ivona voices found"
    fi
fi
#echo $voices



if [ "$1" = "enter" ] ; then
        sleep 1
        export DISPLAY=${display}
	while true; do
		id=`xprop -root |fgrep '_NET_ACTIVE_WINDOW(WINDOW)' | awk '{print $5}' | grep 0x`
		if test "$id" != "" ; then
			if xprop -id $id | grep '^WM_NAME\(STRING\)[= ]+"IVONA ControlCenter"'; then
				xte "keydown Alt_L" "key F4" "keyup Alt_L"
				exit 0
			fi
			#xprop -id $id | grep WM_CLASS
			if xprop -id $id | grep '^WM_CLASS.*"Wine"' ; then
				xte "key Return"
			fi
		fi
		sleep 1
	done
fi

echo killServer | nc 127.0.0.1 8765
killall wineserver
killall wine
rm -rf ~/$wine

open_xvfb ${display}


sleep 3
export DISPLAY=${display}
export WINEPREFIX=$HOME/$wine

icewm &
bpid=$!



echo 'y' | /bin/bash install_sapi.sh $wine


if [ "${voices}" != "" ] ; then
    /bin/bash $0 enter &
    apid=$!

    for voice in ${voices}; do
        wine ${voice}
    done

    kill $apid

    echo Ivona voices installed, reinstalling sapi
    cd $sapi
    echo 'y' | /bin/bash install_sapi.sh $wine

    ivodir="${WINEPREFIX}/drive_c/Program Files/IVONA/IVONA 2 Voice"
    if [ -f "${ivodir}/polish-ivona.lex" ] ; then
        echo "Removing Polish Ivona lex files"
        mv "${ivodir}/polish-ivona.lex" "${ivodir}/polish-ivona.lex.orig"
        cp ivona_data/polish-ivona.lex "${ivodir}/polish-ivona.lex"
        mv "${ivodir}/polish-prm.lex" "${ivodir}/polish-prm.lex.orig"
    fi
#wine ivona_data/center2.dat
fi

echo Creating server wrapper command in ~/bin/sapi_server.sh
mkdir -p ~/bin
cat > ~/bin/sapi_server.sh << END
#!/bin/bash
echo killServer | nc 127.0.0.1 8765
if [ "$1" == "stop" ] ; then
    exit 0
fi
export WINEPREFIX=${WINEPREFIX}
export DISPLAY=${display}
if ! xdpyinfo >/dev/null 2>/dev/null ; then
    nohup Xvfb -screen -0 800x600x16 -nolisten tcp ${display} &
    sleep 2
fi
cd ${sapi}
nohup wine \
    open-sapi/bin/tclsh85.exe \
    open-sapi/server/opensapi-srv.tcl --port 8765 --timeout 0 >/dev/null 2>/dev/null &
END
chmod 755 ~/bin/sapi_server.sh

echo Running server
nohup wine \
		open-sapi/bin/tclsh85.exe \
		open-sapi/server/opensapi-srv.tcl --port 8765 --timeout 0 >/dev/null 2>/dev/null &
kill $bpid
